src/Entity/Item.php
<?php

namespace App\Entity;

use Doctrine\Common\Collections\ArrayCollection;
use Doctrine\Common\Collections\Collection;
use Doctrine\ORM\Mapping as ORM;
use Symfony\Component\Validator\Constraints as Assert;
use Symfony\Component\HttpFoundation\File\File;
use Vich\UploaderBundle\Mapping\Annotation as Vich;

/**
 * @ORM\Entity(repositoryClass="App\Repository\ItemRepository")
 * @Vich\Uploadable

 */
class Item
{
    /**
     * @ORM\Id()
     * @ORM\GeneratedValue()
     * @ORM\Column(type="integer")
     */
    private $id;

    /**
     * @ORM\Column(type="string", length=255)
     */
    private $name;

    /**
     * @ORM\Column(type="string", length=255)
     */
    private $brand;

    /**
     * @ORM\Column(type="integer")
     */
    private $price;

    /**
     * @ORM\Column(type="integer")
     */
    private $nbre_tickets;

    /**
     * @ORM\Column(type="string", nullable=true)
     * @Assert\File(mimeTypes={ "image/png", "image/jpeg" })
     */
    private $image;

    /**
     * @ORM\Column(type="text")
     */
    private $description;

    /**
     * @ORM\Column(type="string", length=255, nullable=true)
     */
    private $brand2;

    /**
     * @ORM\Column(type="string", length=255)
     */
    private $size;

    /**
     * @ORM\Column(type="string", length=255)
     */
    private $category;

    /**
     * @ORM\Column(type="boolean")
     */
    private $check_tickets;

    /**
     * @ORM\Column(type="string", length=255)
     */
    private $price_ticket;

    /**
     * @ORM\Column(type="boolean")
     */
    private $sold;

    /**
     * @ORM\Column(type="date", nullable=true)
     */
    private $date;

    /**
     * @ORM\OneToOne(targetEntity="App\Entity\Orders", mappedBy="item", cascade={"persist", "remove"})
     */
    private $order;

    /**
     * @ORM\ManyToOne(targetEntity="App\Entity\User", inversedBy="items")
     */
    private $seller;

    /**
     * @ORM\Column(type="integer")
     */
    private $soldTickets;

    /**
     * @ORM\OneToMany(targetEntity="App\Entity\Ticket", mappedBy="item")
     */
    private $tickets;

    /**
     * @ORM\ManyToOne(targetEntity="App\Entity\User", inversedBy="itemWinner")
     */
    private $winner;

    public function __construct()
    {
        $this->tickets = new ArrayCollection();
    }

    public function getImage()
    {
        return $this->image;
    }

    public function setImage($image)
    {
        $this->image = $image;

        return $this;
    }

    public function getId()
    {
        return $this->id;
    }

    public function getname(): ?string
    {
        return $this->name;
    }

    public function setname(string $name): self
    {
        $this->name = $name;

        return $this;
    }

    public function getbrand(): ?string
    {
        return $this->brand;
    }

    public function setbrand(string $brand): self
    {
        $this->brand = $brand;

        return $this;
    }

    public function getprice(): ?int
    {
        return $this->price;
    }

    public function setprice(int $price): self
    {
        $this->price = $price;

        return $this;
    }

    public function getNbreTickets(): ?int
    {
        return $this->nbre_tickets;
    }

    public function setNbreTickets(int $nbre_tickets): self
    {
        $this->nbre_tickets = $nbre_tickets;

        return $this;
    }

    public function getDescription(): ?string
    {
        return $this->description;
    }

    public function setDescription(string $description): self
    {
        $this->description = $description;

        return $this;
    }

    public function getBrand2(): ?string
    {
        return $this->brand2;
    }

    public function setBrand2(?string $brand2): self
    {
        $this->brand2 = $brand2;

        return $this;
    }
    public function getSize(): ?string
    {
        return $this->size;
    }

    public function setSize(string $size): self
    {
        $this->size = $size;

        return $this;
    }

    public function getCategory(): ?string
    {
        return $this->category;
    }

    public function setCategory(string $category): self
    {
        $this->category = $category;

        return $this;
    }

    public function getCheckTickets(): ?bool
    {
        return $this->check_tickets;
    }

    public function setCheckTickets(bool $check_tickets): self
    {
        $this->check_tickets = $check_tickets;

        return $this;
    }

    public function getPriceTicket(): ?string
    {
        return $this->price_ticket;
    }

    public function setPriceTicket(string $price_ticket): self
    {
        $this->price_ticket = $price_ticket;

        return $this;
    }

    public function getSold(): ?bool
    {
        return $this->sold;
    }

    public function setSold(bool $sold): self
    {
        $this->sold = $sold;

        return $this;
    }

    public function getDate(): ?\DateTimeInterface
    {
        return $this->date;
    }

    public function setDate(?\DateTimeInterface $date): self
    {
        $this->date = $date;

        return $this;
    }

    public function getOrder(): ?Orders
    {
        return $this->order;
    }

    public function setOrder(Orders $order): self
    {
        $this->order = $order;

        // set the owning side of the relation if necessary
        if ($this !== $order->getItemID()) {
            $order->setItemID($this);
        }

        return $this;
    }

    public function getSeller(): ?User
    {
        return $this->seller;
    }

    public function setSeller(?User $seller): self
    {
        $this->seller = $seller;

        return $this;
    }

    public function getSoldTickets(): ?int
    {
        return $this->soldTickets;
    }

    public function setSoldTickets(int $soldTickets): self
    {
        $this->soldTickets = $soldTickets;

        return $this;
    }

    /**
     * @return Collection|Ticket[]
     */
    public function getTickets(): Collection
    {
        return $this->tickets;
    }

    public function addTicket(Ticket $ticket): self
    {
        if (!$this->tickets->contains($ticket)) {
            $this->tickets[] = $ticket;
            $ticket->setItem($this);
        }

        return $this;
    }

    public function removeTicket(Ticket $ticket): self
    {
        if ($this->tickets->contains($ticket)) {
            $this->tickets->removeElement($ticket);
            // set the owning side to null (unless already changed)
            if ($ticket->getItem() === $this) {
                $ticket->setItem(null);
            }
        }

        return $this;
    }

    public function getWinner(): ?User
    {
        return $this->winner;
    }

    public function setWinner(?User $winner): self
    {
        $this->winner = $winner;

        return $this;
    }
}

src/Form/ItemType.php
<?php

namespace App\Form;

use App\Entity\Item;
use Symfony\Component\Form\Extension\Core\Type\ChoiceType;
use Symfony\Component\Form\Extension\Core\Type\IntegerType;
use Symfony\Component\Form\FormTypeInterface;
use Symfony\Component\Form\AbstractType;
use Symfony\Component\Form\Extension\Core\Type\DateType;
use Symfony\Component\Form\Extension\Core\Type\HiddenType;
use Symfony\Component\Form\FormBuilderInterface;
use Symfony\Component\OptionsResolver\OptionsResolver;
use Symfony\Component\Form\Extension\Core\Type\FileType;


class ItemType extends AbstractType
{
    public function buildForm(FormBuilderInterface $builder, array $options)
    {
        $builder
            ->add('name')
            ->add('brand',ChoiceType::class,[
                'choices'=>[
                    "Supreme"=>"Supreme",
                    "Palace"=>"Palace",
                    "Balenciaga"=>"Balenciaga",
                    "Off-White"=>"Off-White",
                    "Gucci"=>"Gucci",
                    "Dior"=>"Dior"
                ],
                'attr'=>[
                    'class'=>'form-control'
                ]
            ])
            ->add('brand2',ChoiceType::class,[
                'choices'=>[
                    "None"=>null,
                    "Supreme"=>"Supreme",
                    "Balenciaga"=>"Balenciaga",
                    "Off-White"=>"Off-White",
                    "Gucci"=>"Gucci",
                    "Dior"=>"Dior"
                ],
                'attr'=>[
                    'class'=>'form-control'
                ]
            ])            ->add('description')
            ->add('price',HiddenType::class,[
                'data'=>0
            ])
            ->add('nbre_tickets')
            ->add('image',FileType::class,array('data_class'=> null, 'label' => 'Image'))
            ->add('size')
            ->add('category')
            ->add('checkTickets',HiddenType::class, [
                'data'=>0
            ])
            ->add('priceTicket')
            ->add('sold',HiddenType::class,[
                'data'=>0
            ])
            ->add('date',HiddenType::class)
            ->add('soldTickets',HiddenType::class,[
                'data'=>0
            ])

        ;
    }

    public function configureOptions(OptionsResolver $resolver)
    {
        $resolver->setDefaults(array(
            'data_class' => Item::class,
        ));
    }
}

src/Controller/ItemController.php
<?php

namespace App\Controller;

use App\Entity\Item;
use App\Entity\Ticket;
use App\Form\BuyTicketsType;
use App\Form\ItemType;
use App\Repository\ItemRepository;
use DateTime;
use Symfony\Bundle\FrameworkBundle\Controller\Controller;
use Symfony\Component\Config\Definition\Exception\Exception;
use Symfony\Component\HttpFoundation\Request;
use Symfony\Component\HttpFoundation\Response;
use Symfony\Component\Routing\Annotation\Route;

/**
 * @Route("/item")
 */
class ItemController extends Controller
{
    /**
     * @Route("/", name="item_index", methods="GET")
     */
    public function index(ItemRepository $itemRepository): Response
    {
        return $this->render('item/catalog.html.twig', ['items' => $itemRepository->findAll()]);
    }

    /**
     * @Route("/new", name="item_new", methods="GET|POST|PATCH")
     */
    public function new(Request $request): Response
    {
        $item = new Item();
        $form = $this->createForm(ItemType::class, $item);
        $form->handleRequest($request);

        if ($form->isSubmitted() && $form->isValid()) {

            $file = $item->getImage();
            $fileName = $this->generateUniqueFileName() . '.' . $file->guessExtension();

            // moves the file to the directory where brochures are stored
            $file->move(
                $this->getParameter('brochures_directory'),
                $fileName
            );

            $item->setImage($fileName);
            $item->setDate(new \DateTime());
            $item->setSeller($this->getUser());

            $em = $this->getDoctrine()->getManager();
            $em->persist($item);
            $em->flush();

            return $this->redirectToRoute('item_index');
        }

        return $this->render('item/new.html.twig', [
            'item' => $item,
            'form' => $form->createView(),
        ]);
    }

    /**
     * @Route("/{id}", name="item_show", methods="GET")
     */
    public function show(Item $item, Request $request): Response
    {
        if ($this->getUser() != null) {

            $form = $this->createForm(BuyTicketsType::class, $item);
            $form->handleRequest($request);

            return $this->render('item/show.html.twig', ['item' => $item, 'user' => $this->getUser()->getMail(),'form2'=>$form->createView()]);
        } else {
            return $this->render('item/show.html.twig', ['item' => $item, 'app.user.username' => '0']);
        }
    }

    /**
     * @Route("/{id}/edit", name="item_edit", methods="GET|POST")
     */
    public function edit(Request $request, Item $item): Response
    {
        $form = $this->createForm(ItemType::class, $item);
        $form->handleRequest($request);

        if ($form->isSubmitted() && $form->isValid()) {


            $file = $item->getImage();

            echo "<script>alert('" . $file . "')</script>";


            $fileName = $this->generateUniqueFileName() . '.' . $file->guessExtension();

            // moves the file to the directory where brochures are stored
            $file->move(
                $this->getParameter('brochures_directory'),
                $fileName
            );

            $item->setImage($fileName);


            $this->getDoctrine()->getManager()->flush();

            return $this->redirectToRoute('item_edit', ['id' => $item->getId()]);
        }

        return $this->render('item/edit.html.twig', [
            'item' => $item,
            'form' => $form->createView(),
        ]);
    }

    /**
     * @Route("/{id}", name="item_delete", methods="DELETE")
     */
    public function delete(Request $request, Item $item): Response
    {
        if ($this->isCsrfTokenValid('delete' . $item->getId(), $request->request->get('_token'))) {
            $em = $this->getDoctrine()->getManager();
            $em->remove($item);
            $em->flush();
        }

        return $this->redirectToRoute('item_index');
    }


    /**
     * @return string
     */
    private function generateUniqueFileName()
    {
        // md5() reduces the similarity of the file names generated by
        // uniqid(), which is based on timestamps
        return md5(uniqid());
    }

    /**
     * @Route("/buyTickets/{id}", name="buyTickets", methods="POST|GET")
     * @throws \Exception
     */
    public function buyItem(Request $request, Item $item)
    {

        //$form = $this->createForm(BuyTicketsType::class,$item);
        //$form->handleRequest($request);

        $entityManager = $this->getDoctrine()->getManager();

        //if ($form->isSubmitted() && $form->isValid()) {

            if ($item->getSoldTickets() < $item->getNbreTickets()) {

                // On incrémente les tickets
                $item->setSoldTickets($item->getSoldTickets()+1);

                 // On crée un ticket
                $ticket = new Ticket();
                $ticket->setItem($item);
                $ticket->setBuyer($this->getUser());
                $ticket->setDate(new \DateTime());
                $ticket->setTicketNumber(1);

                $entityManager->persist($ticket);
                $entityManager->flush();


                // On persiste
                $this->getDoctrine()->getManager()->flush();

           }
            return $this->redirectToRoute('item_show', ['id' => $item->getId()]);
        //}
       // return $this->render('item/show.html.twig', ['item' => $item, 'user' => $this->getUser()->getMail(),'form2'=>$form->createView()]);

    }
}

templates/item/_delete_form.html.twig
<form method="post" action="{{ path('item_delete', {'id': item.id}) }}" onsubmit="return confirm('Are you sure you want to delete this item?');">
    <input type="hidden" name="_method" value="DELETE">
    <input type="hidden" name="_token" value="{{ csrf_token('delete' ~ item.id) }}">
    <button class="btn btn-danger btnshow">Delete</button>
</form>

templates/item/_form.html.twig
{{ form_start(form) }}

<div form class="ui form">
    <div class="form border rounded px-5 py-3 mb-5">

        <div class="form-group">
            <label>Name</label>
            {{ form_errors(form.name) }}
            {{ form_widget(form.name) }}
        </div>

        <div class="form-row">
            <div class="form-group col-md-6">
                <label>Brand</label>
                {{ form_errors(form.brand) }}
                {{ form_widget(form.brand) }}
            </div>
            <div class="form-group col-md-6">
                <label>Brand 2 (collaboration)</label>
                {{ form_errors(form.brand2) }}
                {{ form_widget(form.brand2) }}
            </div>
        </div>

        <div class="form-row">
            <div class="form-group col-md-6">
                <label>Category</label>
                {{ form_errors(form.category) }}
                {{ form_widget(form.category) }}
            </div>
            <div class="form-group col-md-6">
                <label>Size</label>
                {{ form_errors(form.size) }}
                {{ form_widget(form.size) }}
            </div>
        </div>

        <div class="form-group" rows="3">
            <label>Description</label>
            {{ form_errors(form.description) }}
            {{ form_widget(form.description) }}
        </div>

        <div class="form-row">
            <div class="form-group col-md-6">
                <label>Price per ticket</label>
                {{ form_errors(form.priceTicket) }}
                {{ form_widget(form.priceTicket) }}
            </div>
            <div class="form-group col-md-6">
                <label>Number of tickets</label>
                {{ form_errors(form.nbre_tickets) }}
                {{ form_widget(form.nbre_tickets) }}
            </div>
        </div>

        <div class="form-group">
            <label>Image</label>
            {{ form_errors(form.image) }}
            {{ form_widget(form.image) }}
        </div>

        <button class="btn btn-primary"> {{ button_label|default('Add the item') }} </button>

    </div>
</div>


<style>
    .form {
        width: 100vh;
        margin: 0 auto;
    }

    label{
        font-weight: bold;
    }
</style>

{{ form_end(form) }}

templates/item/catalog.html.twig
{% extends 'base.html.twig' %}

{% block body %}
    <h1 class="text-center mb-5">Catalog</h1>

    <div class="container-fluid">
        <div class="row">
            <nav class="col-md-2 d-none d-md-block bg-light sidebar">
                <div class="sidebar-sticky">
                    <ul class="nav flex-column">
                        <li class="nav-active">
                            <p class="p-3">Filter by</p>
                        </li>
                        <li class="nav-item">
                            <a class="nav-link active" href="#">
                                <span data-feather="home"></span>
                                Brand <span class="sr-only">(current)</span>
                            </a>
                        </li>
                        <li class="nav-item">
                            <a class="nav-link" href="#">
                                <span data-feather="file"></span>
                                Size
                            </a>
                        </li>
                        <li class="nav-item">
                            <a class="nav-link" href="#">
                                <span data-feather="shopping-cart"></span>
                                Type
                            </a>
                        </li>
                        <li class="nav-item">
                            <a class="nav-link" href="#">
                                <span data-feather="users"></span>
                                Price
                            </a>
                        </li>
                    </ul>
                </div>
            </nav>

            <main role="main" class="col-10 ml-sm-auto col-lg-10 pl-1 text-center mx-auto">

                <div class="col-12 text-center mx-auto">
                    <div class="row mx-auto">

                        {% set i = 1 %}
                        {% for item in items %}

                        <div class="card col-3 ml-1 mr-1 mb-3 p-1 mx-auto" onclick="location.href='{{ item.id }}'">

                            <a href="#"><img class="card-img-top img-catalog"
                                             src="{{ asset("/uploads/"~item.image) }}"
                                             alt="Card image cap"></a>
                            <div class="card-body">
                                <h3 class="card-title"><a href="#">{{ item.name }} - {{ item.brand }}</a></h3>
                                <p class="card-text text-center">{{ item.price }}€</p>
                                <p class="card-text">{{ item.description }}</p>
                            </div>
                            {%  set percent = item.soldTickets*100/item.nbreTickets %}
                            <div class="ui indicating progress active" data-percent="{{ percent }}">
                                <div class="bar" style="width:{{ percent }}%;"></div>
                                <div class="label">Progress</div>
                            </div>

                        </div>
                        {% if i == 4 %}
                    </div>
                    <div class="row">

                        {% set i = 0 %}
                        {% endif %}
                        {% set i=i+1 %}
                        {% endfor %}

                    </div>
                </div>
            </main>
        </div>
    </div>


    <style>
    .img-catalog {

        max-height:150px;
        width:auto;

    }

    </style>
{% endblock %}

templates/item/edit.html.twig
{% extends 'base.html.twig' %}

{% block title %}Edit Item{% endblock %}

{% block body %}
    <h1>Edit Item</h1>

    {{ include('item/_form.html.twig', {'button_label': 'Update'}) }}

    <a href="{{ path('item_index') }}">back to list</a>

    {{ include('item/_delete_form.html.twig') }}

<style media="screen">
  body {
    text-align: center;
  }
</style>
{% endblock %}

templates/item/index.html.twig
{% extends 'base.html.twig' %}

{% block title %}Item index{% endblock %}

{% block body %}
<h1>Item index</h1>

<table class="table">
  <thead>
    <tr>
      <th>Id</th>
      <th>Nom</th>
      <th>Marque</th>
      <th>Prix</th>
      <th>Nbre_tickets</th>
      <th>actions</th>
    </tr>
  </thead>
  <tbody>
    {% for item in items %}
    <tr>
      <td>{{ item.id }}</td>
      <td>{{ item.name }}</td>
      <td>{{ item.brand }}</td>
      <td>{{ item.price }}</td>
      <td>{{ item.nbreTickets }}</td>
      <td>
        <a href="{{ path('item_show', {'id': item.id}) }}">show</a>
        <a href="{{ path('item_edit', {'id': item.id}) }}">edit</a>
      </td>
    </tr>
    {% else %}
    <tr>
      <td colspan="6">no records found</td>
    </tr>
    {% endfor %}
  </tbody>
</table>

<div class="container">
  <div class="card-deck">


    {% for item in items %}
    <div class="card border-dark" style="width:12rem" onclick="location.href='{{ 'item/'~item.id }}'">
      <img class="card-img-top minimg" src="{{ asset('/uploads/'~item.image) }}">
      <div class="card-body">
        <h5 class="card-title">{{ item.name }}&nbsp;<span class="badge badge-primary">New</span></h5>
        <div class="card-text">
          <p>{{ item.brand }}</p>
          <p>{{ item.price }}€</p>
        </div>
        <a href="#" class="btn btn-primary btn-info" >View more</a>

      </div>

    </div>
    {% endfor %}
  </div>
</div>

<a href="{{ path('item_new') }}">Create new</a>
{% endblock %}

templates/item/new.html.twig
{% extends 'base.html.twig' %}

{% block title %}New Item{% endblock %}

{% block body %}
    <h1>New Item</h1>

    {{ include('item/_form.html.twig') }}

    <a class="btn btn-secondary mb-5" href="{{ path('item_index') }}">Back</a>
    <style media="screen">
      body {
        text-align: center;
      }
    </style>
{% endblock %}

templates/item/show.html.twig
{% extends 'base.html.twig' %}


{% block title %}Item{% endblock %}

{% block body %}

    <div class="container">
        <div class="row">
            <div class="col-md-8">
                <img class="img-fluid" src="{{ asset('/uploads/'~item.image) }}" alt="">

            </div>
            <div class="col-md-4">
                <h2>{{ item.name }}</h2>
                <h4>{{ item.brand }}</h4>
                <p><strong>Size :</strong> {{ item.size }}</p>
                <p><strong>Category :</strong> {{ item.category }}</p>
                {% if item.nbreTickets > 0 %}
                    <p><strong>Tickets :</strong> {{ item.nbreTickets }}</p>
                    <p><strong>Price per ticket :</strong> {{ item.priceTicket }}{{ item.seller.currency.symbol }}</p>

                    <!-- Progress bar -->
                    {% set percent = item.soldTickets*100/item.nbreTickets %}
                    <div class="ui indicating progress active" data-percent="{{ percent }}">
                        <div class="bar" style="width:{{ percent }}%;"></div>
                        <div class="label">Progress</div>
                    </div>

                {% endif %}


                {% if app.user %}
                    {% if app.user.username == item.seller.mail %}

                        <form class="editForm" action="{{ path('item_edit', {'id': item.id}) }}" method="post">

                            <button class="btn btn-primary btnshow">Edit</button>
                        </form>

                        {{ include('item/_delete_form.html.twig') }}
                    {% else %}
                        {% if percent < 100 %}
                            <a href="#copModal" data-toggle="modal" class="btn btn-success btnshow">Cop</a>
                        {% endif %}
                    {% endif %}
                {% endif %}

                <a class='btn btn-secondary' href="{{ path('item_index') }}">Back</a>

            </div>
        </div>
    </div>

    {% if app.user %}

        <!-- Case : connected -->
        <div id="copModal" class="modal" tabindex="-1" role="dialog" aria-labelledby="copModalLabel">
            <div class="modal-dialog" role="document">
                <div class="modal-content">
                    <div class="modal-header">
                        <h5 class="modal-title">Buy tickets</h5>
                        <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                            <span aria-hidden="true">&times;</span>
                        </button>
                    </div>
                    <div class="modal-body">
                        <p>Price per ticket : <strong>{{ item.priceTicket }}€</strong></p>
                        <p>You are about to purchase <strong>1</strong> ticket</p>

                    </div>
                    <div class="modal-footer">
                        <button type="button" class="btn btn-secondary" data-dismiss="modal">Close</button>
                        <a class="btn btn-success" href="{{ path('buyTickets', {'id':item.id}) }}">Buy ticket</a>
                    </div>
                </div>
            </div>
        </div>
    {% else %}
        <!-- Case : Not Connected -->
        <div id="copModal" class="modal" tabindex="-1" role="dialog" aria-labelledby="copModalLabel">
            <div class="modal-dialog" role="document">
                <div class="modal-content">
                    <div class="modal-header">
                        <h5 class="modal-title">Buy tickets</h5>
                        <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                            <span aria-hidden="true">&times;</span>
                        </button>
                    </div>
                    <div class="modal-body">
                        <p>You need to be connected to buy tickets.</p>
                    </div>
                    <div class="modal-footer">
                        <a class="btn btn-primary" href="{{ path('app_login') }}">Login</a>
                        <button type="button" class="btn btn-secondary" data-dismiss="modal">Close</button>
                    </div>
                </div>
            </div>
        </div>
    {% endif %}

    <style media="screen">
        a {
            margin: 0 auto;
        }

        .btnshow {
            margin: 0 auto;
            width: 100%;
            margin-bottom: 1%;
        }

        .editForm {
            margin: 0 auto;
        }
    </style>

{% endblock %}